• Codeforces Round #370 (Div. 2) D. Memory and Scores DP


    D. Memory and Scores
     

    Memory and his friend Lexa are competing to get higher score in one popular computer game. Memory starts with score a and Lexa starts with score b. In a single turn, both Memory and Lexa get some integer in the range [ - k;k] (i.e. one integer among - k,  - k + 1,  - k + 2, ...,  - 2,  - 1, 0, 1, 2, ..., k - 1, k) and add them to their current scores. The game has exactly t turns. Memory and Lexa, however, are not good at this game, so they both always get a random integer at their turn.

    Memory wonders how many possible games exist such that he ends with a strictly higher score than Lexa. Two games are considered to be different if in at least one turn at least one player gets different score. There are (2k + 1)2t games in total. Since the answer can be very large, you should print it modulo 109 + 7. Please solve this problem for Memory.

    Input
     

    The first and only line of input contains the four integers abk, and t (1 ≤ a, b ≤ 100, 1 ≤ k ≤ 1000, 1 ≤ t ≤ 100) — the amount Memory and Lexa start with, the number k, and the number of turns respectively.

    Output
     

    Print the number of possible games satisfying the conditions modulo 1 000 000 007 (109 + 7) in one line.

    Examples
    input
     
    1 2 2 1

    output
     
    6

    Note

    In the first sample test, Memory starts with 1 and Lexa starts with 2. If Lexa picks  - 2, Memory can pick 0, 1, or 2 to win. If Lexa picks  - 1, Memory can pick 1 or 2 to win. If Lexa picks 0, Memory can pick 2 to win. If Lexa picks 1 or 2, Memory cannot win. Thus, there are3 + 2 + 1 = 6 possible games in which Memory wins.

     题意:

      A,B两人玩t轮游戏

      每轮游戏没人可以从[-k,k]中获取任意的一个分数

      AB起始分数分别为a,b

      问你最终A分数严格比B多的方案数

    题解:

      设定dp[i][j]为第i轮 获得分数j的方案数

      这个可以进行滚动数组和前缀和优化

      最后枚举一个人的 分数 得到答案

    #include<iostream>
    #include<algorithm>
    #include<cstdio>
    #include<cstring>
    #include<cmath>
    #include<vector>
    #include<queue>
    #include<set>
    using namespace std;
    
    #pragma comment(linker, "/STACK:102400000,102400000")
    #define ls i<<1
    #define rs ls | 1
    #define mid ((ll+rr)>>1)
    #define pii pair<int,int>
    #define MP make_pair
    
    typedef long long LL;
    const long long INF = 1e18;
    const double Pi = acos(-1.0);
    const int N = 5e5+10, M = 1e2+11, mod = 1e9+7, inf = 2e9;
    
    int a,b,k,t;
    LL sum[N], dp[2][N];
    int main() {
            scanf("%d%d%d%d",&a,&b,&k,&t);
            int now = 1;
            int last = now ^ 1;
            dp[last][0] = 1;
            for(int i = 0; i <= 2 * k * t; ++i) sum[i] = 1;
            for(int i = 1; i <= t; ++i) {
                for(int  j = 0; j <= 2*k*t; ++j) {
                    if(j <= 2 * k) dp[now][j] = sum[j];
                    else {
                        dp[now][j] = (( sum[j] - sum[j - 2*k - 1] ) % mod + mod ) % mod;
                    }
                }
                sum[0] = dp[now][0];
                for(int j = 1; j <= 4 * k * t; ++j)
                    sum[j] = ((sum[j-1] + dp[now][j]) % mod + mod) % mod;
                now^=1;
            }
            LL ans = 0;
            for(int i = 0; i <= 2 * k * t; ++i) {
                if(a + i - 1 - b >= 0)ans = (ans + dp[now^1][i] * sum[a + i - 1 - b]%mod) % mod;
            }
            cout<<(ans+mod) % mod<<endl;
            return 0;
    }
  • 相关阅读:
    【开源我写的富文本】打造全网最劲富文本系列之技术选型
    【开源我写的富文本】打造全网最劲富文本技术选型之经典OOP仍是魅力硬核。
    Jquery会死吗?我为什么不用vue写富文本!
    JavaScript的因为所以
    JavaScript寻踪OOP之路
    JavaScript谁动了你的代码
    JavaScript神一样的变量系统
    JavaScript的前世今生
    ASPICE对追踪性和一致性要求
    ASPICE:能力等级评定
  • 原文地址:https://www.cnblogs.com/zxhl/p/5869901.html
Copyright © 2020-2023  润新知